SystemOrganization addCategory: #'Pier-Slideshow'!

PRWidget subclass: #PRSlideshow
	instanceVariableNames: 'current ajaxId'
	classVariableNames: 'NoChildrenFound'
	poolDictionaries: ''
	category: 'Pier-Slideshow'!

!PRSlideshow class methodsFor: 'descriptions-navigation' stamp: 'lr 4/10/2009 11:30'!
descriptionClickSlide
	^ MABooleanDescription new
		checkboxLabel: 'Slide Click';
		selectorAccessor: #slideClick;
		group: 'Navigation Controls';
		default: true;
		priority: 200;
		yourself! !

!PRSlideshow class methodsFor: 'descriptions-animation' stamp: 'lr 4/10/2009 11:34'!
descriptionDelay
	^ MANumberDescription new
		selectorAccessor: #delay;
		group: 'Animation';
		label: 'Delay (ms)';
		priority: 300;
		default: 0;
		yourself! !

!PRSlideshow class methodsFor: 'descriptions-navigation' stamp: 'lr 4/10/2009 11:30'!
descriptionFirstLast
	^ MABooleanDescription new
		group: 'Navigation Controls';
		selectorAccessor: #firstLast;
		checkboxLabel: 'First/Last';
		default: false;
		priority: 210;
		yourself! !

!PRSlideshow class methodsFor: 'descriptions-navigation' stamp: 'lr 4/10/2009 11:30'!
descriptionPrevNext
	^ MABooleanDescription new
		checkboxLabel: 'Previous/Next';
		group: 'Navigation Controls';
		selectorAccessor: #prevNext;
		default: false;
		priority: 220;
		yourself! !

!PRSlideshow class methodsFor: 'descriptions-navigation' stamp: 'lr 4/10/2009 11:31'!
descriptionSlideList
	^ MABooleanDescription new
		checkboxLabel: 'Slide Listing';
		group: 'Navigation Controls';
		selectorAccessor: #slideList;
		default: false;
		priority: 230;
		yourself! !

!PRSlideshow class methodsFor: 'descriptions-navigation' stamp: 'lr 4/10/2009 11:31'!
descriptionSlideNumber
	^ MABooleanDescription new
		selectorAccessor: #slideNumber;
		checkboxLabel: 'Slide Number';
		group: 'Navigation Controls';
		default: false;
		priority: 240;
		yourself! !

!PRSlideshow class methodsFor: 'descriptions-animation' stamp: 'lr 4/10/2009 11:36'!
descriptionTransition
	^ MANumberDescription new
		selectorAccessor: #transition;
		label: 'Transition (ms)';
		group: 'Animation';
		priority: 310;
		default: 0;
		yourself! !

!PRSlideshow class methodsFor: 'initialization' stamp: 'lr 8/22/2007 11:59'!
initialize
	NoChildrenFound := PRPage named: 'unnamed'.
	NoChildrenFound
		contents: 'Please add slides to this widget.'! !

!PRSlideshow class methodsFor: 'testing' stamp: 'lr 8/22/2007 11:51'!
isAbstract
	^ false! !

!PRSlideshow class methodsFor: 'accessing' stamp: 'lr 8/22/2007 11:53'!
label
	^ 'Slideshow'! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 4/10/2009 14:01'!
current
	"Answer the current slides to display."

	^ current ifNil: [ current := self slides first ]! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 8/22/2007 12:04'!
current: aStructure
	current := aStructure! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 4/10/2009 11:37'!
delay
	^ self read: #descriptionDelay! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 4/10/2009 14:01'!
goFirst
	"Go to the first slide."

	self current: self slides first! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 9/12/2007 18:18'!
goLast
	"Go to the last slide."

	self current: self slides last! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 4/10/2009 11:15'!
goNext
	"Go to the next slide."

	self current: (self slides
		after: self current
		ifAbsent: [ self slides first ])! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 9/12/2007 18:18'!
goPrev
	"Go to the previous slide."

	self current: (self slides
		before: self current
		ifAbsent: [ self slides last ])! !

!PRSlideshow methodsFor: 'testing' stamp: 'lr 4/10/2009 11:31'!
hasClickSlide
	^ self read: #descriptionClickSlide! !

!PRSlideshow methodsFor: 'testing' stamp: 'lr 4/10/2009 11:17'!
hasFirstLast
	^ self read: #descriptionFirstLast! !

!PRSlideshow methodsFor: 'testing' stamp: 'lr 4/10/2009 11:17'!
hasPrevNext
	^ self read: #descriptionPrevNext! !

!PRSlideshow methodsFor: 'testing' stamp: 'lr 4/10/2009 11:18'!
hasSlideList
	^ self read: #descriptionSlideList! !

!PRSlideshow methodsFor: 'testing' stamp: 'lr 4/10/2009 11:18'!
hasSlideNumber
	^ self read: #descriptionSlideNumber! !

!PRSlideshow methodsFor: 'testing' stamp: 'lr 4/10/2009 14:18'!
hasTools
	^ self hasFirstLast or: [ self hasPrevNext or: [ self hasSlideList or: [ self hasSlideNumber ] ] ]! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 4/10/2009 14:20'!
renderContentOn: html
	html div
		class: 'slideshow';
		style: 'position: relative';
		id: (ajaxId := html nextId);
		script: (self delay > 0 ifTrue: [
			(self update: [ self goNext ] on: html)
				every: (self delay + self transition) / 1000 ]);
		with: [ self renderSlideshowOn: html ]! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 4/10/2009 11:52'!
renderControl: aString class: aClassString enabled: aBoolean action: aBlock on: html
	aBoolean
		ifTrue: [
			aBlock fixCallbackTemps.
			html anchor
				callback: aBlock;
				class: aClassString;
				onClick: ((self update: aBlock on: html) 
					return: false);
				with: aString ]
		ifFalse: [
			html span
				class: aClassString;
				with: aString ]! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 9/12/2007 18:18'!
renderControlFirstOn: html
	self
		renderControl: '|<' class: 'first'
		enabled: self current ~= self slides first
		action: [ self goFirst ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 9/12/2007 18:18'!
renderControlLastOn: html
	self
		renderControl: '>|' class: 'last'
		enabled: self current ~= self slides last
		action: [ self goLast ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 9/12/2007 18:18'!
renderControlNextOn: html
	self
		renderControl: '>>' class: 'next'
		enabled: self current ~= self slides last
		action: [ self goNext ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 9/12/2007 18:18'!
renderControlPrevOn: html
	self
		renderControl: '<<' class: 'prev'
		enabled: self current ~= self slides first
		action: [ self goPrev ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 4/10/2009 12:25'!
renderControlSlideListOn: html
	| selectId |
	html select
		class: 'navig';
		list: self slides;
		selected: self current;
		id: (selectId := html nextId);
		labels: [ :value | value title ];
		callback: [ :value | self current: value ];
		onChange: ((self update: [ ] on: html) triggerFormElement: selectId)! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 4/10/2009 12:01'!
renderSlideNumberOn: html
	html span class: 'number'; title: self current title; with: [
		html span
			class: 'current';
			with: (self slides indexOf: self current).
		html span
			class: 'separator';
			with: '/'.
		html span
			class: 'total';
			with: (self slides size) ]! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 4/10/2009 13:36'!
renderSlideOn: html
	self renderSlideStyled: nil on: html! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 4/10/2009 13:36'!
renderSlideStyled: aStyle on: html
	html div
		class: 'slide';
		style: aStyle;
		title: self current title; 
		onClick: (self hasClickSlide
			ifTrue: [ self update: [ self goNext ] on: html ]);
		with: [
			html rendererInstance
				continue: self current
				in: self on: html ]! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 4/10/2009 12:26'!
renderSlideTitleOn: html
	html span 
		class: 'title';
		with: self current title! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 4/10/2009 13:43'!
renderSlideshowOn: html
	self renderSlideOn: html.
	self hasTools ifTrue: [ 
		html div 
			class: 'tools'; 
			with: [ self renderToolsOn: html ] ]! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 4/10/2009 13:43'!
renderToolsOn: html 
	self hasFirstLast ifTrue: [ self renderControlFirstOn: html ].
	self hasPrevNext ifTrue: [ self renderControlPrevOn: html ].
	self hasSlideList ifTrue: [ self renderControlSlideListOn: html ].
	self hasPrevNext ifTrue: [ self renderControlNextOn: html ].
	self hasFirstLast ifTrue: [ self renderControlLastOn: html ].
	self hasSlideNumber ifTrue: [ self renderSlideNumberOn: html ]! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 4/10/2009 14:17'!
slides
	"Answer the possible slides to display."

	| slides |
	slides := self structure enumerator contents.
	^ slides isEmpty
		ifFalse: [ slides ]
		ifTrue: [ Array with: NoChildrenFound ]! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 4/10/2009 14:16'!
structure
	"Answer the owning structure, the structure this component is defined at."

	^ self owner! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 4/10/2009 11:37'!
transition
	^ self read: #descriptionTransition! !

!PRSlideshow methodsFor: 'scripting' stamp: 'lr 4/10/2009 13:34'!
update: aBlock on: html
	^ html scriptaculous evaluator callback: [ :script |
		aBlock value.
		self transition <= 0
			ifTrue: [ self updateReplaceOn: script ]
			ifFalse: [ self updateAnimateOn: script ] ]! !

!PRSlideshow methodsFor: 'scripting' stamp: 'lr 4/10/2009 13:54'!
updateAnimateOn: aScript
	aScript element
		id: ajaxId; down: '.slide';
		insertBefore: [ :r | self renderSlideStyled: 'display: none; position: absolute; top: 0;' on: r ].
	self hasTools ifTrue: [
		aScript element
			id: ajaxId; down: '.tools';
			update: nil ].
	aScript effect
 		appear;
		duration: self transition / 1000;
		id: (SUElement new id: ajaxId; down: '.slide');
		onAfterFinish: (SUElement new
			id: ajaxId; down: '.slide'; next: '.slide';
			remove) , (SUElement new
			id: ajaxId; down: '.slide';
			styleAt: 'position' put: nil;
			styleAt: 'top' put: nil) , (self hasTools ifTrue: [ 
				(SUElement on: aScript canvas)
					id: ajaxId; down: '.tools';
					update: [ :r | self renderToolsOn: r ] ])! !

!PRSlideshow methodsFor: 'scripting' stamp: 'lr 4/10/2009 13:32'!
updateReplaceOn: aScript
	aScript element
		id: ajaxId;
		update: [ :r | self renderSlideshowOn: r ]! !
PRSlideshow initialize!
